/* This file is part of GNU epsilon, a functional language implementation

Copyright (C) 2006 Luca Saiu

GNU epsilon is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 2, or (at your
option) any later version.

GNU epsilon is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU epsilon; if not, write to the Free Software Foundation, Inc.,
51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */


/* This simple benchmark is a direct translation of an eAML file, used to
   compare the performance of the eAM with raw C. */

#include "stack.h"
#include "fast_stack.h"
#include <assert.h>

#define M 10000
#define N 50000

word_t st_fast_stack;
word_t st_fast_stack_top_pointer;
word_t st_fast_stack_allocated_size;
integer_t i;
integer_t j;
integer_t x;
integer_t sum;

int main(){
  eam_initialize_stacks();
  eam_create_fast_stack_with_top_pointer(65536, st);
  for(i = 0; i < M; i++){
    eam_push_word_onto_fast_stack((word_t)-1, st);
    for(j = N; j >= 0; j--)
      eam_push_word_onto_fast_stack((word_t)j, st);
    sum = 0;
  second_loop:
    x = (integer_t)eam_pop_word_from_fast_stack(st);
    if(x == -1) goto end_of_second_loop;  
    sum += x;
    goto second_loop;
  end_of_second_loop:
    ;
  } // for
  printf(INTEGER_T_FORMAT"\n", sum);
  eam_finalize_stacks();
    
  return 0;
}
