//////////////////////////////
#include "driver.h"

char *eam_esomething_unmangled_name = "something";
integer_t eam_esomething_globals_no = 4;

static integer_t integers[3] = { (integer_t)10, (integer_t)20, (integer_t)30};

word_t eam_esomething_global_1 = (word_t)123456789;
word_t eam_esomething_global_2 = (word_t)"abcd";
static word_t eam_esomething_global_3 = (word_t)(integer_t)123;
word_t eam_esomething_global_4 = (word_t)integers;

void eam_esomething_initialize(void){
  fprintf(stderr, "[Initializing something]\n");
}

void eam_esomething_finalize(void){
  fprintf(stderr, "[Finalizing something]\n");
}

integer_t eam_esomething_blocks_no = 3;

EAM_DECLARE_EXPORTED_BLOCK(eam_esomething_label_1);
EAM_DECLARE_INTERNAL_BLOCK(eam_esomething_label_2);
EAM_DECLARE_EXPORTED_BLOCK(eam_esomething_label_3);

EAM_BEGIN_EXPORTED_BLOCK(eam_esomething_label_1);
  fprintf(stderr, "[block 1 (exported) something]\n");
  EAM_FAST_JUMP(eam_esomething_label_2);
EAM_END_BLOCK

EAM_BEGIN_INTERNAL_BLOCK(eam_esomething_label_2);
  fprintf(stderr, "[block 2 (internal) something]\n");
  EAM_FAST_JUMP(eam_esomething_label_3);
EAM_END_BLOCK

EAM_BEGIN_EXPORTED_BLOCK(eam_esomething_label_3);
  fprintf(stderr, "[block 3 (exported) something]\n");
  return NULL;
EAM_END_BLOCK
/////////////////////////////////////////////////////

/* This file is part of GNU epsilon, a functional language implementation

Copyright (C) 2006 Luca Saiu

GNU epsilon is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 2, or (at your
option) any later version.

GNU epsilon is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU epsilon; if not, write to the Free Software Foundation, Inc.,
51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */


#include "modules.h"

#define MODULE "/home/luca/progetti/epsilon/epsilon-working/eam/bin/libhello.la"
#define MODULE2 "/home/luca/progetti/epsilon/epsilon-working/eam/bin/libhello2.la"
//#define MODULE "/home/luca/progetti/epsilon/epsilon-working/eam/bin/q.so"

int main(){
  eam_initialize_eam_modules();
  while(1){
    struct eam_module *f = eam_load_module("something", NULL);
    fprintf(stderr, "%p\n", f);
    struct eam_module *m = eam_load_module("hello", MODULE);
    struct eam_module *n = eam_load_module("hello", MODULE);
    struct eam_module *o = eam_load_module("hello", MODULE);
    fprintf(stderr, "%p %p %p\n", m, n, o);
    assert(m != NULL);
    assert(n != NULL);
    assert(o != NULL);
    assert(m == n);
    assert(n == o);
    fprintf(stderr, "["INTEGER_T_FORMAT"]\n", *(integer_t*)eam_access_global(m, 1));
    (*(integer_t*)eam_access_global(m, 1))++;
    fprintf(stderr, "["INTEGER_T_FORMAT"]\n", *(integer_t*)eam_access_global(m, 1));
    fprintf(stderr, "------------------------------------------------\n");
    eam_call_block(m, 1);
    eam_call_block(f, 1);
    fprintf(stderr, "------------------------------------------------\n");
    if(m != NULL) eam_unload_module(m);
    if(n != NULL) eam_unload_module(n);
    if(o != NULL) eam_unload_module(o);
    eam_unload_module_given_its_name("something");
    eam_unload_module(f);
  } // while
  eam_finalize_eam_modules();
  return 0;
}
