/* This file is part of GNU epsilon, a functional language implementation

Copyright (C) 2005 Luca Saiu
Updated by Luca Saiu in 2006

GNU epsilon is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 2, or (at your
option) any later version.

GNU epsilon is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU epsilon; if not, write to the Free Software Foundation, Inc.,
51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */


#ifndef EAM_GENERATE_C_H_
#define EAM_GENERATE_C_H_

#include "../common/types.h"
#include "eaml.h"
#include "symbol_table.h"
#include "../common/filesystem.h"
#include "generate_including_c.h"

/* Translate the given compilation unit in the given file using the given
   already-filled symbol table, into a C file to be written in the given
   directory.
   Fail with a fatal error on any error condition: */
void eam_generate_c_file(
        const struct eam_compilation_unit *compilation_unit,
        const struct eam_symbol_table *symbol_table,
        const char *output_directory_for_c_file);

#endif // #ifndef EAM_GENERATE_C_H_
