/* This file is part of GNU epsilon, a functional language implementation

Copyright (C) 2006 Luca Saiu

GNU epsilon is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 2, or (at your
option) any later version.

GNU epsilon is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU epsilon; if not, write to the Free Software Foundation, Inc.,
51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */


#include <stdio.h>
#include <sys/stat.h>
#include <string.h>
#include "../common/malloc.h"
#include "repository.h"

/* To do. */

#if 0
#include <gdbm.h>
struct eam_repository{
  /* A (locally malloc()ed and copied) string holding the current repository
     path name: */
  char *path_name;
  
  /* The GDBM file handler: */
  GDBM_FILE handler;
}; // struct

static struct eam_repository* eam_open_repository_with_flags(const char *path_name,
                                           int flags){
  struct eam_repository *r = (struct eam_repository*)
    eam_xmalloc(sizeof(struct eam_repository));
  r->path_name = eam_xmalloc(strlen(path_name) + 1);
  strcpy(r->path_name, path_name);
  r->handler = gdbm_open(r->path_name, 0, flags, getumask(), NULL);
  
  fprintf(stderr, "+ Repository: %s initialized\n", path_name);
  return r;
}

struct eam_repository* eam_open_repository_for_reading(const char *path_name){
  return eam_open_repository_with_flags(path_name, GDBM_READER);
}

struct eam_repository* eam_open_repository_for_writing(const char *path_name){
  return eam_open_repository_with_flags(path_name, GDBM_WRITER);
}

void eam_close_repository(struct eam_repository *repository){
  gdbm_close(repository->handler);
  fprintf(stderr, "+ Repository: %s finalized\n", repository->path_name);
  free(repository->path_name);
  free(repository);
}
#endif
