/* This file is part of GNU epsilon, a functional language implementation

Copyright (C) 2006 Luca Saiu

GNU epsilon is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 2, or (at your
option) any later version.

GNU epsilon is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU epsilon; if not, write to the Free Software Foundation, Inc.,
51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */


#ifndef EAM_TRANSLATOR_REPOSITORY_H_
#define EAM_TRANSLATOR_REPOSITORY_H_

#include "../common/types.h"
#include "eaml.h"

/* Just a stub, by now. To do. */

/* An opaque repository handler: */
struct eam_repository;

/* Open the given repository. Note that writing implies reading: */
struct eam_repository* eam_open_repository_for_reading(const char *path_name);
struct eam_repository* eam_open_repository_for_writing(const char *path_name);

/* Close the last open repository: */
void eam_close_repository(struct eam_repository* repository);

#endif // #ifndef EAM_TRANSLATOR_REPOSITORY_H_
